stages:    
  - build
  - deploy

build-job:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  variables:
    GIT_STRATEGY: clone
  script:
    # build webapp image
    - docker build -t competence_api_image .
    # zip image
    - docker save -o competence_api_image.tar competence_api_image
  artifacts:
    paths:
    - competence_api_image.tar
    expire_in: 1 day  


deploy-job:      # This job runs in the deploy stage.
  stage: deploy  
  dependencies:
    - build-job
  variables:
    GIT_STRATEGY: clone
  before_script:
    # Prepare access via ssh with public private key
    - 'command -v ssh-agent >/dev/null || ( apk update && apk add openssh )'
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - ssh-keyscan "$GATESERVER"
    - ssh-keyscan "$GATESERVER" >> ~/.ssh/known_hosts
    - echo "$SERVERKEY" >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
  script:
    # connect to server via jump host and remove old container and image
    - ssh -o StrictHostKeyChecking=no -J "$USERNAME"@"$GATESERVER" "$USERNAME"@"$SERVER" "docker rm -f competence_api &> /dev/null || true" 
    - ssh -o StrictHostKeyChecking=no -J "$USERNAME"@"$GATESERVER" "$USERNAME"@"$SERVER" "docker image rm competence_api_image &> /dev/null || true" 
    - ssh -o StrictHostKeyChecking=no -J "$USERNAME"@"$GATESERVER" "$USERNAME"@"$SERVER" "rm /home/dev/competence/competence_api/competence_api_image.tar &> /dev/null || true" 
    # copy and load new image from build stage to server
    - scp -o StrictHostKeyChecking=no -o 'ProxyJump "$USERNAME"@"$GATESERVER"' competence_api_image.tar "$USERNAME"@"$SERVER":/home/dev/competence/competence_api
    - ssh -o StrictHostKeyChecking=no -J "$USERNAME"@"$GATESERVER" "$USERNAME"@"$SERVER" "docker load -i /home/dev/competence/competence_api/competence_api_image.tar"
    # remove old docker-compose-server.yml file and copy new one to server
    - ssh -o StrictHostKeyChecking=no -J "$USERNAME"@"$GATESERVER" "$USERNAME"@"$SERVER" "rm /home/dev/competence/competence_api/docker-compose.prod.yml &> /dev/null || true"
    - scp -o StrictHostKeyChecking=no -o 'ProxyJump "$USERNAME"@"$GATESERVER"' docker-compose.prod.yml "$USERNAME"@"$SERVER":/home/dev/competence/competence_api
    # run docker-compose
    - ssh -o StrictHostKeyChecking=no -J "$USERNAME"@"$GATESERVER" "$USERNAME"@"$SERVER" "docker compose -f /home/dev/competence/competence_api/docker-compose.prod.yml --env-file /home/dev/competence/competence_api/.env  up -d" 
    # execute necessary commands in webapp container
    - ssh -o StrictHostKeyChecking=no -J "$USERNAME"@"$GATESERVER" "$USERNAME"@"$SERVER" "docker exec competence_api python manage.py collectstatic --no-input"
    - ssh -o StrictHostKeyChecking=no -J "$USERNAME"@"$GATESERVER" "$USERNAME"@"$SERVER" "docker exec competence_api python manage.py migrate" 
  only:
    - main
